struct gotype {
	const char *name;
	const char *usbname;
	const char *familyname;
	const char *projectname;
	const char *btname;
	const char *requiredbootloader;
	unsigned short id;
	unsigned short usbproductid;
	unsigned int  linuxfreq;
	unsigned int  bootloaderfreq;
	unsigned int  backlightfreq;
	unsigned char touchscreen;
	unsigned char tsxchannel;
	unsigned char tsychannel;
	unsigned char cputype;
	unsigned char bluetooth;
	unsigned char btchip;
	unsigned char btusb;
	unsigned int  btspeed;
	unsigned int  btclock;
	unsigned int  btclass;
	unsigned char handsfree;
	unsigned char headsetgw;
	unsigned char a2dp;
	unsigned char lowbutton;
	unsigned char battery;
	unsigned char chargertype;
	unsigned char sdcard;
	unsigned char harddisk;
	unsigned char tsfets;
	unsigned char remote;
	unsigned char docking;
	unsigned char tfttype;
	unsigned char gpstype;
	unsigned char gpsephemeris;
	unsigned char headphoneconnector;
	unsigned char speaker;
	unsigned char codectype;
	unsigned char codecmaster;
	unsigned char acctype;
	unsigned char usbslavetype;
	unsigned char memsize;
	unsigned char lightsensor;
	unsigned char gpio_headlight;
	unsigned char gpio_autoshutdown;
	unsigned char gyro;
	unsigned char ohciports;
	unsigned char harddisktiming;
	unsigned char loquendo;
	unsigned char regulatorforcodec;
	unsigned char ioexpander;
	unsigned char rxddetect;
	unsigned char pulldowns;
	unsigned char tftsoftstart;
	unsigned char s3c2412ors3c2413;
	unsigned char real_shutdown;
	unsigned char usbbuspowered;
};

#define IO_GetModelId()				(gotype_current.id)
#define IO_GetModelName()			(gotype_current.name)
#define IO_GetFamilyName()			(gotype_current.familyname)
#define IO_GetProjectName()			(gotype_current.projectname)
#define IO_GetUsbName()				(gotype_current.usbname)
#define IO_GetBtName()				(gotype_current.btname)
#define IO_GetCpuType()				(gotype_current.cputype)
#define IO_GetLinuxFreq()			(gotype_current.linuxfreq)
#define IO_GetBootloaderFreq()		(gotype_current.bootloaderfreq)
#define IO_HaveBluetooth()			(gotype_current.bluetooth)
#define IO_GetBluetoothChip()		(gotype_current.btchip)
#define IO_HaveBluetoothUsb()		(gotype_current.btusb)
#define IO_GetBluetoothSpeed()		(gotype_current.btspeed)
#define IO_GetBluetoothClock()		(gotype_current.btclock)
#define IO_GetBluetoothClass()		(gotype_current.btclass)
#define IO_HaveHandsfree()			(gotype_current.handsfree)
#define IO_HaveHeadsetGw()			(gotype_current.headsetgw)
#define IO_HaveA2DP()				(gotype_current.a2dp)
#define IO_HaveLoweredButton()		(gotype_current.lowbutton)
#define IO_HaveBattery()			(gotype_current.battery)
#define IO_GetChargerType()			(gotype_current.chargertype)
#define IO_HaveSdCard()				(gotype_current.sdcard)
#define IO_HaveHarddisk()			(gotype_current.harddisk)
#define IO_HaveTsFets()				(gotype_current.tsfets)
#define IO_HaveRemote()				(gotype_current.remote)
#define IO_HaveDocking()			(gotype_current.docking)
#define IO_HaveGpioHeadlights()		(gotype_current.gpio_headlight)
#define IO_HaveGpioAutoShutdown()	(gotype_current.gpio_autoshutdown)
#define IO_HaveUsbBusPowered()		(gotype_current.usbbuspowered)
#define IO_GetTftType()				(gotype_current.tfttype)
#define IO_GetTsXChannel()			(gotype_current.tsxchannel)
#define IO_GetTsYChannel()			(gotype_current.tsychannel)
#define IO_GetGpsType()				(gotype_current.gpstype)
#define IO_HaveGpsEphemeris()		(gotype_current.gpsephemeris)
#define IO_HaveHeadphoneConnector()	(gotype_current.headphoneconnector)
#define IO_HaveSpeaker()			(gotype_current.speaker)
#define IO_GetCodecType()			(gotype_current.codectype)
#define IO_GetCodecMaster()			(gotype_current.codecmaster)
#define IO_GetAccType()				(gotype_current.acctype)
#define IO_GetUSBSlaveType()		(gotype_current.usbslavetype)
#define IO_GetUSBProductID()		(gotype_current.usbproductid)
#define IO_GetMemSize()				(gotype_current.memsize)
#define IO_HaveLightSensor()		(gotype_current.lightsensor)
#define IO_HaveGyro()				(gotype_current.gyro)
#define IO_UsbOhciPortMask()		(gotype_current.ohciports)
#define IO_GetHarddiskTiming()      (gotype_current.harddisktiming)
#define IO_HaveTS()					(gotype_current.touchscreen)
#define IO_HaveRealShutdown()		(gotype_current.real_shutdown)
#define IO_HaveLoquendo()           (gotype_current.loquendo)
#define IO_HaveRegulatorForCodec()  (gotype_current.regulatorforcodec)
#define IO_HaveIoExpander()         (gotype_current.ioexpander)
#define IO_HaveRxdDetect()          (gotype_current.rxddetect)
#define IO_HavePullDowns()          (gotype_current.pulldowns)
#define IO_GetRequiredBootloader()  (gotype_current.requiredbootloader)
#define IO_HaveTftSoftStart()       (gotype_current.tftsoftstart)
#define IO_HaveS3C2412OrS3C2413()   (gotype_current.s3c2412ors3c2413)
#define IO_GetBacklightFreq()       (gotype_current.backlightfreq)
#define IO_GetCpuFreq IO_GetLinuxFreq
